Index: java/main/src/main/java/com/framsticks/util/dispatching/Thread.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 105)
@@ -46,5 +46,4 @@
 		log.debug("starting thread {}", this);
 		assert getMonitor() != null;
-		ExceptionHandler exceptionHandler = getMonitor().getTaskExceptionHandler();
 		while (!java.lang.Thread.interrupted()) {
 			RunAt<? extends C> runnable;
@@ -64,4 +63,5 @@
 					runnable.run();
 				} catch (Exception e) {
+					final ExceptionDispatcherHandler exceptionHandler = getMonitor().getTaskExceptionHandler();
 					if (exceptionHandler != null) {
 						if (exceptionHandler.handle(this, e)) {
@@ -122,5 +122,5 @@
 	// @Override
 	// public String toString() {
-	// 	return getName();
+	//	return getName();
 	// }
 
Index: java/main/src/main/java/com/framsticks/util/dispatching/ThrowExceptionHandler.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/ThrowExceptionHandler.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/util/dispatching/ThrowExceptionHandler.java	(revision 105)
@@ -1,7 +1,8 @@
 package com.framsticks.util.dispatching;
 
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 
-public class ThrowExceptionHandler implements ExceptionResultHandler {
+public class ThrowExceptionHandler implements ExceptionHandler {
 
 	private static final ThrowExceptionHandler instance = new ThrowExceptionHandler();
Index: java/main/src/test/java/com/framsticks/core/ListChangeTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/core/ListChangeTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/core/ListChangeTest.java	(revision 105)
@@ -6,5 +6,4 @@
 import org.testng.annotations.Test;
 
-import com.framsticks.core.ListChange.Action;
 import static com.framsticks.params.AccessOperations.*;
 import com.framsticks.params.FramsClass;
@@ -12,4 +11,6 @@
 import com.framsticks.params.ListSource;
 import com.framsticks.params.ReflectionAccess;
+import com.framsticks.structure.messages.ListChange;
+import com.framsticks.structure.messages.ListChange.Action;
 import com.framsticks.test.TestConfiguration;
 
Index: java/main/src/test/java/com/framsticks/core/LocalTreeTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/core/LocalTreeTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/core/LocalTreeTest.java	(revision 105)
@@ -12,4 +12,8 @@
 import com.framsticks.model.f0.Schema;
 import com.framsticks.model.f0.SchemaBuilder;
+import com.framsticks.structure.LocalTree;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.Tree;
+import com.framsticks.structure.TreeOperations;
 import com.framsticks.test.TestConfiguration;
 import com.framsticks.util.dispatching.Dispatching;
@@ -20,8 +24,9 @@
 import com.framsticks.params.types.FloatParam;
 
-import static com.framsticks.core.TreeOperations.*;
 
 
 import static org.fest.assertions.Assertions.*;
+import static com.framsticks.params.ParamsUtil.getParam;
+import static com.framsticks.structure.TreeOperations.*;
 
 @Test
@@ -75,6 +80,6 @@
 				assertThat(access.get("se", Double.class)).isEqualTo(1.0);
 
-				assertThat(bindAccess(tree, "/parts/2").getFramsClass().getParamEntry("m", FloatParam.class).getDef(Double.class)).isEqualTo(1.0);
-				assertThat(bindAccess(tree, "/parts/2").getFramsClass().getParamEntry("m", FloatParam.class).getMax(Double.class)).isEqualTo(999.0);
+				assertThat(getParam(bindAccess(tree, "/parts/2"), "m", FloatParam.class).getDef(Double.class)).isEqualTo(1.0);
+				assertThat(getParam(bindAccess(tree, "/parts/2"), "m", FloatParam.class).getMax(Double.class)).isEqualTo(999.0);
 				assertThat(bindAccess(tree, "/parts/2")).isInstanceOf(ReflectionAccess.class);
 				assertThat(Path.to(tree, "/neurodefs").getTopObject()).isInstanceOf(ArrayList.class);
Index: java/main/src/test/java/com/framsticks/core/PathTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/core/PathTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/core/PathTest.java	(revision 105)
@@ -11,4 +11,5 @@
 import org.testng.annotations.Test;
 
+import com.framsticks.structure.Path;
 import com.framsticks.test.TestConfiguration;
 import com.framsticks.util.lang.Pair;
Index: java/main/src/test/java/com/framsticks/gui/LocalTreeBrowserTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/gui/LocalTreeBrowserTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/gui/LocalTreeBrowserTest.java	(revision 105)
@@ -5,12 +5,13 @@
 import org.testng.annotations.Test;
 
-import com.framsticks.core.Tree;
-import com.framsticks.core.LocalTree;
 import com.framsticks.model.Model;
 import com.framsticks.params.types.FloatParam;
 import com.framsticks.parsers.XmlLoader;
+import com.framsticks.structure.LocalTree;
+import com.framsticks.structure.Tree;
 import com.framsticks.util.dispatching.RunAt;
 
-import static com.framsticks.core.TreeOperations.*;
+import static com.framsticks.params.ParamsUtil.getParam;
+import static com.framsticks.structure.TreeOperations.*;
 
 @Test
@@ -45,5 +46,5 @@
 			@Override
 			protected void runAt() {
-				assertThat(bindAccess(tree, "/parts/2").getFramsClass().getParamEntry("m", FloatParam.class).getMax(Double.class)).isEqualTo(999.0);
+				assertThat(getParam(bindAccess(tree, "/parts/2"), "m", FloatParam.class).getMax(Double.class)).isEqualTo(999.0);
 			}
 		});
Index: java/main/src/test/java/com/framsticks/gui/ProcedureBrowserTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/gui/ProcedureBrowserTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/gui/ProcedureBrowserTest.java	(revision 105)
@@ -7,20 +7,20 @@
 import org.testng.annotations.Test;
 
-import com.framsticks.core.Path;
-import com.framsticks.core.Tree;
-import com.framsticks.core.LocalTree;
-import com.framsticks.core.ValueChange;
 import com.framsticks.params.Access;
 import com.framsticks.params.EventListener;
-import com.framsticks.params.FramsClass;
 import com.framsticks.params.ReflectionAccess;
 import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.StringParam;
 import com.framsticks.parsers.XmlLoader;
+import com.framsticks.structure.LocalTree;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.Tree;
+import com.framsticks.structure.messages.ValueChange;
 import com.framsticks.test.TestClass;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Future;
 // import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.RunAt;
-import static com.framsticks.core.TreeOperations.*;
+import static com.framsticks.params.ParamsUtil.getParam;
+import static com.framsticks.structure.TreeOperations.*;
 
 @Test
@@ -53,5 +53,5 @@
 			@Override
 			protected void runAt() {
-				assertThat(bindAccess(tree, "/").getFramsClass().getParam("history")).isInstanceOf(StringParam.class);
+				assertThat(getParam(bindAccess(tree, "/"), "history")).isInstanceOf(StringParam.class);
 			}
 		});
@@ -64,10 +64,9 @@
 				Access access = bindAccess(tree, "/");
 				assertThat(access).isInstanceOf(ReflectionAccess.class);
-				FramsClass framsClass = access.getFramsClass();
-				assertThat(framsClass.getParam(0).getId()).isEqualTo("name");
-				assertThat(framsClass.getParam(1).getId()).isEqualTo("history");
-				assertThat(framsClass.getParam(2).getId()).isEqualTo("history_changed");
-				assertThat(framsClass.getParam(3).getId()).isEqualTo("appendHistory");
-				assertThat(framsClass.getParam(4).getId()).isEqualTo("resetHistory");
+				assertThat(getParam(access, 0).getId()).isEqualTo("name");
+				assertThat(getParam(access, 1).getId()).isEqualTo("history");
+				assertThat(getParam(access, 2).getId()).isEqualTo("history_changed");
+				assertThat(getParam(access, 3).getId()).isEqualTo("appendHistory");
+				assertThat(getParam(access, 4).getId()).isEqualTo("resetHistory");
 
 				assertThat(access.get("history", String.class)).isEqualTo("initial|");
@@ -96,5 +95,5 @@
 				assertThat(access.get("history", String.class)).isEqualTo("initial|Żółw|");
 
-				tree.addListener(Path.to(tree, "/"), access.getFramsClass().getParamEntry("history_changed", EventParam.class), listener, ValueChange.class, FutureHandler.doNothing(Void.class, failOnException));
+				tree.addListener(Path.to(tree, "/"), getParam(access, "history_changed", EventParam.class), listener, ValueChange.class, Future.doNothing(Void.class, failOnException));
 			}
 		});
@@ -109,5 +108,5 @@
 				assertThat(access.get("history", String.class)).isEqualTo("");
 
-				tree.removeListener(Path.to(tree, "/"), access.getFramsClass().getParamEntry("history_changed", EventParam.class), listener, FutureHandler.doNothing(Void.class, failOnException));
+				tree.removeListener(Path.to(tree, "/"), getParam(access, "history_changed", EventParam.class), listener, Future.doNothing(Void.class, failOnException));
 			}
 		});
Index: java/main/src/test/java/com/framsticks/gui/console/TrackConsoleTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/gui/console/TrackConsoleTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/gui/console/TrackConsoleTest.java	(revision 105)
@@ -3,14 +3,14 @@
 import org.testng.annotations.Test;
 
-import com.framsticks.core.Path;
 import com.framsticks.gui.GuiTest;
 import com.framsticks.remote.RemoteTree;
+import com.framsticks.structure.Path;
 import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.Dispatching.Waiter;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableCollection;
 
-import static com.framsticks.core.TreeOperations.*;
+import static com.framsticks.structure.TreeOperations.*;
 
 @Test
@@ -41,5 +41,5 @@
 		final Waiter waiter = produceWaiter(1.0);
 
-		tryGet(tree, "/simulator/genepools/groups/0", new FutureHandler<Path>(failOnException) {
+		tryGet(tree, "/simulator/genepools/groups/0", new Future<Path>(failOnException) {
 
 			@Override
Index: java/main/src/test/java/com/framsticks/hosting/ServerTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/hosting/ServerTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/hosting/ServerTest.java	(revision 105)
@@ -8,15 +8,15 @@
 import org.testng.annotations.Test;
 
-import com.framsticks.core.ListChange;
-import com.framsticks.core.LocalTree;
-import com.framsticks.core.Path;
-import com.framsticks.core.Result;
-import com.framsticks.core.TreeOperations;
-import com.framsticks.core.ValueChange;
 import com.framsticks.core.XmlBasedTest;
 import com.framsticks.remote.RemoteTree;
+import com.framsticks.structure.LocalTree;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.Tree;
+import com.framsticks.structure.TreeOperations;
+import com.framsticks.structure.messages.ListChange;
+import com.framsticks.structure.messages.Result;
+import com.framsticks.structure.messages.ValueChange;
 
 import com.framsticks.test.TestClass;
-import com.framsticks.core.Tree;
 import com.framsticks.params.FramsClass;
 import com.framsticks.params.Access;
@@ -29,10 +29,12 @@
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.dispatching.Dispatching.Waiter;
-import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.RunAt;
 
-import static com.framsticks.core.TreeOperations.*;
+import static com.framsticks.params.ParamsUtil.arguments;
 
 import static org.fest.assertions.Assertions.*;
+import static com.framsticks.params.ParamsUtil.getParam;
+import static com.framsticks.structure.TreeOperations.*;
 
 @Test
@@ -72,5 +74,5 @@
 		final Waiter waiter = produceWaiter(1.0);
 
-		TreeOperations.tryGet(remote, "/testClass", new FutureHandler<Path>(failOnException) {
+		TreeOperations.tryGet(remote, "/testClass", new Future<Path>(failOnException) {
 			@Override
 			protected void result(Path path) {
@@ -88,5 +90,5 @@
 		final Waiter waiter = produceWaiter(1.0);
 
-		TreeOperations.tryGet(remote, "/testClass", new FutureHandler<Path>(failOnException) {
+		TreeOperations.tryGet(remote, "/testClass", new Future<Path>(failOnException) {
 			@Override
 			protected void result(Path path) {
@@ -105,5 +107,5 @@
 		final Waiter waiter = produceWaiter(2.0);
 
-		set(remotePath, remoteTestFramsClass.getParamEntry("name", PrimitiveParam.class), "new name", new FutureHandler<Integer>(failOnException) {
+		set(remotePath, getParam(remoteTestFramsClass, "name", PrimitiveParam.class), "new name", new Future<Integer>(failOnException) {
 			@Override
 			protected void result(Integer flags) {
@@ -132,5 +134,5 @@
 		};
 
-		TreeOperations.tryGet(remote, "/cli/events", new FutureHandler<Path>(failOnException) {
+		TreeOperations.tryGet(remote, "/cli/events", new Future<Path>(failOnException) {
 			@Override
 			protected void result(Path path) {
@@ -139,5 +141,5 @@
 		});
 
-		addListener(remotePath, remoteTestFramsClass.getParamEntry("history_changed", EventParam.class), listener, ValueChange.class, produceWaiter(1.0).passInFuture(Void.class));
+		addListener(remotePath, getParam(remoteTestFramsClass, "history_changed", EventParam.class), listener, ValueChange.class, produceWaiter(1.0).passInFuture(Void.class));
 	}
 
@@ -146,7 +148,7 @@
 		final Waiter waiter = produceWaiter(2.0);
 
-		call(remotePath, remoteTestFramsClass.getParamEntry("resetHistory", ProcedureParam.class), new Object[] {}, Object.class, produceWaiter(2.0).passInFuture(Object.class));
-
-		call(remotePath, remoteTestFramsClass.getParamEntry("appendHistory", ProcedureParam.class), new Object[] {"next word"}, Result.class, new FutureHandler<Result>(failOnException) {
+		call(remotePath, getParam(remoteTestFramsClass, "resetHistory", ProcedureParam.class), arguments(), Object.class, produceWaiter(2.0).passInFuture(Object.class));
+
+		call(remotePath, getParam(remoteTestFramsClass, "appendHistory", ProcedureParam.class), arguments("next word"), Result.class, new Future<Result>(failOnException) {
 			@Override
 			protected void result(final Result result) {
@@ -167,5 +169,5 @@
 	@Test(dependsOnMethods = "callMethod")
 	public void deregisterListener() {
-		removeListener(remotePath, remoteTestFramsClass.getParamEntry("history_changed", EventParam.class), listener, produceWaiter(1.0).passInFuture(Void.class));
+		removeListener(remotePath, getParam(remoteTestFramsClass, "history_changed", EventParam.class), listener, produceWaiter(1.0).passInFuture(Void.class));
 
 		assertThat(listenerArguments).isEqualTo(Arrays.asList("", "next word|"));
@@ -183,5 +185,5 @@
 		};
 
-		addListener(remotePath, remoteTestFramsClass.getParamEntry("children_changed", EventParam.class), childListener, ListChange.class, produceWaiter(1.0).passInFuture(Void.class));
+		addListener(remotePath, getParam(remoteTestFramsClass, "children_changed", EventParam.class), childListener, ListChange.class, produceWaiter(1.0).passInFuture(Void.class));
 	}
 
@@ -189,12 +191,12 @@
 	public void createChild() {
 		final Waiter waiter = produceWaiter(2.0);
-		call(remotePath, "createChild", new Object[] { "a child" }, Object.class, produceWaiter(2.0).passInFuture(Object.class));
-		call(remotePath, "createChild", new Object[] { "another child" }, Object.class, produceWaiter(2.0).passInFuture(Object.class));
-
-		tryGet(remote, "/testClass/children/c0", new FutureHandler<Path>(failOnException) {
+		call(remotePath, "createChild", arguments("a child"), Object.class, produceWaiter(2.0).passInFuture(Object.class));
+		call(remotePath, "createChild", arguments("another child"), Object.class, produceWaiter(2.0).passInFuture(Object.class));
+
+		tryGet(remote, "/testClass/children/c0", new Future<Path>(failOnException) {
 
 			@Override
 			protected void result(Path result) {
-				set(result, getFramsClass(result).getParamEntry("name", StringParam.class), "new_name", new FutureHandler<Integer>(failOnException) {
+				set(result, getParam(result, "name", StringParam.class), "new_name", new Future<Integer>(failOnException) {
 
 					@Override
@@ -209,5 +211,5 @@
 	@Test(dependsOnMethods = "createChild")
 	public void deregisterChildListener() {
-		removeListener(remotePath, remoteTestFramsClass.getParamEntry("children_changed", EventParam.class), childListener, produceWaiter(1.0).passInFuture(Void.class));
+		removeListener(remotePath, getParam(remoteTestFramsClass, "children_changed", EventParam.class), childListener, produceWaiter(1.0).passInFuture(Void.class));
 	}
 
Index: java/main/src/test/java/com/framsticks/model/CreatureTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/model/CreatureTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/model/CreatureTest.java	(revision 105)
@@ -11,4 +11,5 @@
 
 import static org.fest.assertions.Assertions.*;
+import static com.framsticks.params.ParamsUtil.getParam;
 
 @Test
@@ -27,5 +28,5 @@
 		assertThat(framsClass.getParam("name")).describedAs("name").isInstanceOf(StringParam.class);
 		assertThat(framsClass.getParam("parts")).describedAs("parts").isInstanceOf(ArrayListParam.class);
-		partsParam = framsClass.getParamEntry("parts", ArrayListParam.class);
+		partsParam = getParam(framsClass, "parts", ArrayListParam.class);
 		assertThat(partsParam).describedAs("partsParam").isNotNull();
 		assertThat(partsParam).isInstanceOf(ArrayListParam.class);
Index: java/main/src/test/java/com/framsticks/model/ModelPackageTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/model/ModelPackageTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/model/ModelPackageTest.java	(revision 105)
@@ -15,4 +15,5 @@
 
 import static org.fest.assertions.Assertions.*;
+import static com.framsticks.params.ParamsUtil.getParam;
 
 @Test
@@ -41,5 +42,5 @@
 				Object defaultValue = args[1];
 
-				ValueParam param = framsClass.getParamEntry(paramName, ValueParam.class);
+				ValueParam param = getParam(framsClass, paramName, ValueParam.class);
 				assertThat(param.getDef(Object.class)).isEqualTo(defaultValue);
 
Index: java/main/src/test/java/com/framsticks/model/f0/SchemaTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/model/f0/SchemaTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/model/f0/SchemaTest.java	(revision 105)
@@ -11,4 +11,5 @@
 
 import static org.fest.assertions.Assertions.*;
+import static com.framsticks.params.ParamsUtil.getParam;
 
 public class SchemaTest extends TestConfiguration {
@@ -23,10 +24,10 @@
 
 		assertThat(schema.getNeuroClass("|").getName()).isEqualTo("Bend muscle");
-		assertThat(schema.getNeuroClass("VEye").getParam("p")).isInstanceOf(FloatParam.class);
-		assertThat(schema.getNeuroClass("VEye").getParamEntry("p", FloatParam.class).getMax(Double.class)).isEqualTo(10.0, delta(0.0));
+		assertThat(getParam(schema.getNeuroClass("VEye"), "p")).isInstanceOf(FloatParam.class);
+		assertThat(getParam(schema.getNeuroClass("VEye"), "p", FloatParam.class).getMax(Double.class)).isEqualTo(10.0, delta(0.0));
 
 		FramsClass partClass = schema.getFramsClass("p");
 		assertThat(partClass).isNotNull();
-		assertThat(partClass.getParamEntry("as", FloatParam.class).getDef(Double.class)).isEqualTo(0.25, delta(0.0));
+		assertThat(getParam(partClass, "as", FloatParam.class).getDef(Double.class)).isEqualTo(0.25, delta(0.0));
 		assertThat(partClass.getGroupCount()).isEqualTo(3);
 		assertThat(partClass.getGroup(1).getName()).isEqualTo("Other properties");
Index: java/main/src/test/java/com/framsticks/params/FramsClassBuilderTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/params/FramsClassBuilderTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/params/FramsClassBuilderTest.java	(revision 105)
@@ -6,9 +6,9 @@
 import org.testng.annotations.Test;
 
-import com.framsticks.core.ValueChange;
 import com.framsticks.params.types.EventParam;
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.params.types.StringParam;
 import com.framsticks.parsers.Savers;
+import com.framsticks.structure.messages.ValueChange;
 import com.framsticks.test.TestClass;
 import com.framsticks.test.TestConfiguration;
@@ -16,4 +16,6 @@
 
 import static org.fest.assertions.Assertions.*;
+import static com.framsticks.params.ParamsUtil.arguments;
+import static com.framsticks.params.ParamsUtil.getParam;
 
 @Test
@@ -43,5 +45,6 @@
 		assertThat(framsClass.getParam("resetHistory")).isInstanceOf(ProcedureParam.class);
 
-		ProcedureParam appendHistory = framsClass.getParamEntry("appendHistory", ProcedureParam.class);
+
+		ProcedureParam appendHistory = getParam(framsClass, "appendHistory", ProcedureParam.class);
 		assertThat(appendHistory.getArgumentsType().size()).isEqualTo(1);
 		assertThat(appendHistory.getArgumentsType().get(0).getId()).isEqualTo("arg0");
@@ -111,5 +114,5 @@
 
 		assertThat(access.get("history", String.class)).isEqualTo("initial|first|");
-		Object result = access.call("appendHistory", new Object[] {"second"});
+		Object result = access.call("appendHistory", arguments("second"));
 
 		assertThat(result).isInstanceOf(Integer.class);
@@ -117,5 +120,5 @@
 		assertThat(access.get("history", String.class)).isEqualTo("initial|first|second|");
 
-		result = access.call("resetHistory", null);
+		result = access.call("resetHistory");
 		assertThat(result).isNull();
 
@@ -136,5 +139,5 @@
 		};
 
-		final EventParam eventParam = access.getFramsClass().getParamEntry("history_changed", EventParam.class);
+		final EventParam eventParam = getParam(access, "history_changed", EventParam.class);
 		access.reg(eventParam, listener);
 
@@ -142,5 +145,5 @@
 		final String addition = "test";
 
-		access.call("appendHistory", new Object[] { addition });
+		access.call("appendHistory", arguments(addition));
 
 		String expected = currentHistory + addition + "|";
Index: java/main/src/test/java/com/framsticks/params/ParamBuilderTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/params/ParamBuilderTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/params/ParamBuilderTest.java	(revision 105)
@@ -9,4 +9,5 @@
 import com.framsticks.test.TestConfiguration;
 import static org.fest.assertions.Assertions.*;
+import static com.framsticks.params.ParamsUtil.getParam;
 
 @Test
@@ -24,6 +25,6 @@
 		assertThat(builderFramsClass.getName()).isEqualTo("prop");
 		assertThat(builderFramsClass.getId()).isEqualTo("prop");
-		assertThat(builderFramsClass.getParamEntry("flags", ValueParam.class).getDef(Object.class)).isEqualTo(new Integer(0));
-		assertThat(builderFramsClass.getParamEntry("id", Param.class)).isInstanceOf(StringParam.class);
+		assertThat(getParam(builderFramsClass, "flags", ValueParam.class).getDef(Object.class)).isEqualTo(new Integer(0));
+		assertThat(getParam(builderFramsClass, "id", Param.class)).isInstanceOf(StringParam.class);
 	}
 
Index: java/main/src/test/java/com/framsticks/params/ParamsUtilTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/params/ParamsUtilTest.java	(revision 105)
+++ java/main/src/test/java/com/framsticks/params/ParamsUtilTest.java	(revision 105)
@@ -0,0 +1,88 @@
+package com.framsticks.params;
+
+import static org.fest.assertions.Assertions.*;
+
+import java.util.Arrays;
+import java.util.Map;
+import java.util.TreeMap;
+
+import org.testng.annotations.Test;
+
+import com.framsticks.params.AccessOperations;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.ListSink;
+import com.framsticks.params.ReflectionAccess;
+import com.framsticks.params.types.UniversalParam;
+import com.framsticks.parsers.Savers;
+import com.framsticks.test.TestConfiguration;
+import com.framsticks.test.TestSerializedClass;
+
+
+public class ParamsUtilTest extends TestConfiguration {
+
+	@Test
+	public void testSerialization() {
+		FramsClass framsClass;
+		ReflectionAccess access;
+
+		framsClass = FramsClass.build().forClass(TestSerializedClass.class);
+		assertThat(framsClass.getParamCount()).isEqualTo(1);
+		assertThat(framsClass.getParam("theArray")).isInstanceOf(UniversalParam.class);
+
+		access = new ReflectionAccess(TestSerializedClass.class, framsClass);
+
+		assertThat(Savers.saveFramsClass(new ListSink(), framsClass).getOut()).isEqualTo(
+				Arrays.asList(
+					"class:",
+					"name:TestSerializedClass",
+					"id:TestSerializedClass",
+					"",
+					"prop:",
+					"id:theArray",
+					"name:TheArray",
+					"type:x",
+					""
+				)
+			);
+
+		TestSerializedClass test = new TestSerializedClass();
+		test.getTheArray().add(1);
+		test.getTheArray().add(3.0);
+		test.getTheArray().add("word");
+
+		ListSink sink = new ListSink();
+		AccessOperations.savePrimitives(access.select(test), sink);
+		assertThat(sink.getOut()).isEqualTo(Arrays.asList(
+				"TestSerializedClass:",
+				"theArray:@Serialized:[1,3.0,\"word\"]",
+				""
+			));
+
+
+		assertThat(ParamsUtil.serialize("@Serialized:")).isEqualTo("@Serialized:\"@Serialized:\"");
+		assertThat(ParamsUtil.serialize(Arrays.asList(12, null, "abc"))).isEqualTo("@Serialized:[12,null,\"abc\"]");
+		assertThat(ParamsUtil.serialize(Arrays.asList(Arrays.asList(Arrays.asList())))).isEqualTo("@Serialized:[[[]]]");
+
+		Map<String, Object> f12 = new TreeMap<String, Object>();
+		f12.put("a", 123);
+		f12.put("b", Arrays.asList(7, 8, 9));
+		assertThat(ParamsUtil.serialize(f12)).isEqualTo("@Serialized:{\"a\":123,\"b\":[7,8,9]}");
+
+		// List<Object> f18 = new ArrayList<>();
+		// List<Object> f18_0 = new ArrayList<>();
+		// List<Object> f18_1 = Arrays.asList("x", f18);
+		// List<Object> f18_2 = new ArrayList<>();
+		// f18_2.add(f18_0);
+		// f18_0.add(f18_2);
+		// f18.add(f18_0);
+		// f18.add(f18_1);
+		// f18.add(f18_2);
+
+		// root[0] is f18_0
+		// root[0]==root[2][0], root[1][1]==root, root[1][1][1][1][0]=="x".
+
+		// assertThat(ParamsUtil.serialize(f18)).isEqualTo("@Serialized:[[^3],[\"x\",^0],[^1]]");
+
+	}
+
+}
Index: java/main/src/test/java/com/framsticks/parsers/F0ParserTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/parsers/F0ParserTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/parsers/F0ParserTest.java	(revision 105)
@@ -17,4 +17,5 @@
 import static org.fest.assertions.Assertions.*;
 import static org.fest.assertions.Delta.*;
+import static com.framsticks.params.ParamsUtil.getParam;
 
 /**
@@ -48,5 +49,5 @@
 	public void primitiveParam() {
 		FramsClass joint = schema.getFramsClass("j");
-		PrimitiveParam<?> dx = joint.getParamEntry("dx", PrimitiveParam.class);
+		PrimitiveParam<?> dx = getParam(joint, "dx", PrimitiveParam.class);
 		assertThat(dx).isInstanceOf(FloatParam.class);
 		assertThat(schema.getNeuroClasses().size()).isEqualTo(21);
@@ -54,5 +55,5 @@
 		assertThat(dx.getMin(Double.class)).isEqualTo(-2.0, delta(0.0));
 
-		assertThat(schema.getRegistry().getFramsClass("n").getParamEntry("d", StringParam.class).getDef(String.class)).isEqualTo("N");
+		assertThat(getParam(schema.getRegistry().getFramsClass("n"), "d", StringParam.class).getDef(String.class)).isEqualTo("N");
 	}
 
@@ -60,5 +61,5 @@
 	public void readF0() throws IOException, ParseException {
 		assertThat(schema.getFramsClass("p")).isInstanceOf(FramsClass.class);
-		assertThat(schema.getRegistry().getFramsClass("p").getParamEntry("as", FloatParam.class).getDef(Double.class)).isEqualTo(0.25, delta(0.0));
+		assertThat(getParam(schema.getRegistry().getFramsClass("p"), "as", FloatParam.class).getDef(Double.class)).isEqualTo(0.25, delta(0.0));
 
 		accesses = new F0Parser(schema, F0ParserTest.class.getResourceAsStream("/parsers/f0_example.txt")).parse();
@@ -91,5 +92,5 @@
 
 		assertThat(model.getParts().get(1).getPosition().x).isEqualTo(2.0, delta(0.0));
-		assertThat(model.getParts().get(2).getPosition().sub(new Point3d(2.27236, -0.0792596, -0.958924)).length()).isLessThan(0.0001);
+		assertThat(model.getParts().get(2).getPosition().sub(new Point3d(2.27236, -0.0792596, -0.958924)).length()).describedAs("position error").isLessThan(0.0001);
 		assertThat(model.getParts().get(2).getOrientation().y.sub(new Point3d(0.870277, -0.404792, 0.280644)).length()).isLessThan(0.0001);
 
Index: java/main/src/test/java/com/framsticks/running/ExternalProcessTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/running/ExternalProcessTest.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/running/ExternalProcessTest.java	(revision 105)
@@ -9,6 +9,6 @@
 import org.testng.annotations.Test;
 
-import com.framsticks.core.ValueChange;
 import com.framsticks.params.EventListener;
+import com.framsticks.structure.messages.ValueChange;
 import com.framsticks.test.TestConfiguration;
 import com.framsticks.util.dispatching.Monitor;
Index: java/main/src/test/java/com/framsticks/test/TestConfiguration.java
===================================================================
--- java/main/src/test/java/com/framsticks/test/TestConfiguration.java	(revision 103)
+++ java/main/src/test/java/com/framsticks/test/TestConfiguration.java	(revision 105)
@@ -10,10 +10,10 @@
 import org.testng.annotations.*;
 
+import com.framsticks.util.ExceptionHandler;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.Dispatching.Waiter;
-import com.framsticks.util.dispatching.ExceptionHandler;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.ExceptionDispatcherHandler;
 
 // import static org.fest.assertions.Assertions.*;
@@ -46,6 +46,6 @@
 	}
 
-	public ExceptionHandler createExceptionHandler() {
-		return new ExceptionHandler() {
+	public ExceptionDispatcherHandler createExceptionHandler() {
+		return new ExceptionDispatcherHandler() {
 			@Override
 			public boolean handle(Dispatcher<?> dispatcher, Throwable throwable) {
@@ -98,5 +98,5 @@
 	}
 
-	public final ExceptionResultHandler failOnException = new ExceptionResultHandler() {
+	public final ExceptionHandler failOnException = new ExceptionHandler() {
 		@Override
 		public void handle(FramsticksException e) {
